﻿using System;
using System.Data;
using MySql.Data.MySqlClient;

namespace MySQL_Repro_App
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                using (var connection = new MySqlConnection("server=localhost;database=new_schema;compress=false;user id=root;password=root;ignoreprepare=false;sslmode=None"))
                {
                    connection.Open();
                    using (var getCustomerUserIDByMetaValueCmd = new MySqlCommand("SELECT user_id FROM wp_usermeta WHERE (meta_key = @MetaKey AND meta_value = @MetaValue);", connection))
                    {
                        getCustomerUserIDByMetaValueCmd.Parameters.AddWithValue("@MetaKey", "phone").MySqlDbType = MySqlDbType.VarChar;
                        getCustomerUserIDByMetaValueCmd.Parameters.AddWithValue("@MetaValue", "111-111-1111").MySqlDbType = MySqlDbType.LongText;
                        //Comment the below line out to "fix" the error.
                        getCustomerUserIDByMetaValueCmd.Prepare();
                        using (var reader = getCustomerUserIDByMetaValueCmd.ExecuteReader(CommandBehavior.SingleRow))
                        {
                            Console.WriteLine("It works!");
                        }
                    }
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("It failed:");
                Console.WriteLine(e);
            }
            Console.ReadLine();
        }
    }
}
